链接:

P2221


题意:

有 \(n(1\leq n\leq 10^5)\) 个点,从第 \(i(1\leq i< n)\) 个点向第 \(i+1\) 个点连有边。最初所有边长 \(v_i\) 为 \(0\)。

有 \(m(1\leq m\leq 10^5)\) 次操作:

  • 操作 \(1\):'C' l r v 表示将 \(l\) 和 \(r\) 之间的所有边长度加上 \(v\)。
  • 操作 \(2\):'Q' l r 在第 \(l\) 个到第 \(r\) 个点里等概率随机取出两个不同的点 \(a\) 和 \(b\),询问 \(a,b\) 的期望距离。

保证:\(1\leq l\leq r\leq n,-10^4\leq v\leq 10^4\),任意时刻满足 \(0\leq v_i\leq 10^4\)。


分析:

分析询问操作,显然是问距离的平均数,也就是\(\dfrac{\sum\limits_{i=l}^{r-1}\sum\limits_{j=i+1}^rdis[i][j]}{(r-l+1)\times(r-l)/2}\)。

分母可以直接算,分子比较难算。

首先化边为点,查询 \([l,r]\) 之间的边也就是 \([l,r-1]\) 的边。

考虑每条边被计算的次数,枚举左右两边的端点,则 \(ans=\sum\limits_{i=l}^{r-1}v[i]\times(i-l+1)\times(r-i+1)\)。

把式子拆开后得到:

\(ans=\sum\limits_{i=l}^{r-1}v[i]*i^2+(l+r)\sum\limits_{i=l}^{r-1}v[i]*i+(-l*r+r-l+1)*\sum\limits_{i=l}^{r-1}v[i]\)

\(\sum\) 前面的东西可以提出来,所以我们只需要每次查询 \(\sum\limits_{i=l}^{r-1}v[i]*i^2,\sum\limits_{i=l}^{r-1}v[i]*i,\sum\limits_{i=l}^{r-1}v[i]\)

线段树维护这三个值,分别记为 \(sum1,sum2,sum3\)

pushup 时直接相加:

inline void pushup(int p){
sum1(p)=sum1(p<<1)+sum1(p<<1|1);
sum2(p)=sum2(p<<1)+sum2(p<<1|1);
sum3(p)=sum3(p<<1)+sum3(p<<1|1);
}

修改时,\(sum1\) 加上 \(d*\sum\limits_{i=l}^ri^2\),\(sum2\) 加上 \(d*\sum\limits_{i=l}^ri\),\(sum3\) 加上 \(d*\sum\limits_{i=l}^r1\)。这些东西都可以 \(O(1)\) 搞出来。

所以分子就维护好了。

由于对边的操作需要我们让 \(r-1\),但分母中的 \(r\) 不能减,所以在 \(r-1\) 后,分母要变成 \((r-l+2)\times(r-l+1)/2\)。

于是这道题就做完了。时间复杂度 \(O(n\log n)\)。


代码:
#include<bits/stdc++.h>
using namespace std;
#define int long long
#define in read()
inline int read(){
int p=0,f=1;
char c=getchar();
while(c>'9'||c<'0'){if(c=='-')f=-1;c=getchar();}
while(c>='0'&&c<='9'){p=p*10+c-'0';c=getchar();}
return p*f;
}
const int N=1e5+5;
int n,m;
inline int gcd(int a,int b){return b?gcd(b,a%b):a;}
#define sum1(x) t[x].sum1
#define sum2(x) t[x].sum2
#define sum3(x) t[x].sum3
#define tag(x) t[x].tag
inline int sumi1(int l,int r){return (l+r)*(r-l+1)/2;}
inline int sumi2(int l,int r){return r*(r+1)/2*(2*r+1)/3-(l-1)*l/2*(2*l-1)/3;}
struct node{
int sum1,sum2,sum3,tag;
}t[N<<2];
inline void pushup(int p){
sum1(p)=sum1(p<<1)+sum1(p<<1|1);
sum2(p)=sum2(p<<1)+sum2(p<<1|1);
sum3(p)=sum3(p<<1)+sum3(p<<1|1);
}
inline void f(int l,int r,int p,int d){
tag(p)+=d;
sum1(p)+=sumi2(l,r)*d;
sum2(p)+=sumi1(l,r)*d;
sum3(p)+=(r-l+1)*d;
}
inline void pushdown(int l,int r,int p){
if(tag(p)){
int mid=(l+r)>>1;
f(l,mid,p<<1,tag(p));
f(mid+1,r,p<<1|1,tag(p));
tag(p)=0;
}
}
inline void change(int l,int r,int p,int cl,int cr,int d){
if(l>=cl&&r<=cr){f(l,r,p,d);return ;}
pushdown(l,r,p);
int mid=(l+r)>>1;
if(cl<=mid)change(l,mid,p<<1,cl,cr,d);
if(cr>mid)change(mid+1,r,p<<1|1,cl,cr,d);
pushup(p);
}
struct ret{
int sum1,sum2,sum3;
};
ret operator+(const ret &x,const ret &y){
ret z;
z.sum1=x.sum1+y.sum1;
z.sum2=x.sum2+y.sum2;
z.sum3=x.sum3+y.sum3;
return z;
}
inline ret query(int l,int r,int p,int ql,int qr){
if(l>=ql&&r<=qr){return {sum1(p),sum2(p),sum3(p)};}
pushdown(l,r,p);
int mid=(l+r)>>1;
ret t={0,0,0};
if(ql<=mid)t=t+query(l,mid,p<<1,ql,qr);
if(qr>mid)t=t+query(mid+1,r,p<<1|1,ql,qr);
return t;
}
signed main(){
n=in,m=in;
for(int i=1;i<=m;i++){
char c[5];
cin>>c;
if(c[0]=='C'){
int l=in,r=in-1,d=in;
change(1,n,1,l,r,d);
}
else{
int l=in,r=in-1;
ret ans=query(1,n,1,l,r);
int ans1=-ans.sum1+(l+r)*ans.sum2+(r-l+1-l*r)*ans.sum3;
int ans2=(r-l+2)*(r-l+1)/2;
int t=gcd(ans1,ans2);
ans1/=t,ans2/=t;
cout<<ans1<<"/"<<ans2<<'\n';
}
}
return 0;
}

洛谷 P2221 [HAOI2012]高速公路的更多相关文章

  1. 洛谷P2221 [HAOI2012]高速公路

    线段树 #include<cstdio> #include<cstdlib> #include<algorithm> #include<cstring> ...

  2. 洛谷P2221 [HAOI2012]高速公路(线段树+概率期望)

    传送门 首先,答案等于$$ans=\sum_{i=l}^r\sum_{j=i}^r\frac{sum(i,j)}{C_{r-l+1}^2}$$ 也就是说所有情况的和除以总的情况数 因为这是一条链,我们 ...

  3. P2221 [HAOI2012]高速公路(线段树)

    P2221 [HAOI2012]高速公路 显然答案为 $\dfrac{\sum_{i=l}^r\sum_{j=l}^{r}dis[i][j]}{C_{r-l+1}^2}$ 下面倒是挺好算,组合数瞎搞 ...

  4. 洛谷 P2220 [HAOI2012]容易题 数论

    洛谷 P2220 [HAOI2012]容易题 题目描述 为了使得大家高兴,小Q特意出个自认为的简单题(easy)来满足大家,这道简单题是描述如下: 有一个数列A已知对于所有的A[i]都是1~n的自然数 ...

  5. 洛谷P2221 高速公路【线段树】

    题目:https://www.luogu.org/problemnew/show/P2221 题意:有n个节点排成一条链,相邻节点之间有一条路. C u v val表示从u到v的路径上的每条边权值都加 ...

  6. 洛谷 P2505 [HAOI2012]道路 解题报告

    P2505 [HAOI2012]道路 题目描述 C国有n座城市,城市之间通过m条单向道路连接.一条路径被称为最短路,当且仅当不存在从它的起点到终点的另外一条路径总长度比它小.两条最短路不同,当且仅当它 ...

  7. 洛谷 P1877 [HAOI2012]音量调节

    P1877 [HAOI2012]音量调节 题目描述 一个吉他手准备参加一场演出.他不喜欢在演出时始终使用同一个音量,所以他决定每一首歌之前他都需要改变一次音量.在演出开始之前,他已经做好一个列表,里面 ...

  8. 洛谷P1877 [HAOI2012]音量调节 [2017年4月计划 动态规划05]

    P1877 [HAOI2012]音量调节 题目描述 一个吉他手准备参加一场演出.他不喜欢在演出时始终使用同一个音量,所以他决定每一首歌之前他都需要改变一次音量.在演出开始之前,他已经做好一个列表,里面 ...

  9. 【题解】Luogu P2221 [HAOI2012]高速公路

    原题传送门 这道题还算简单 我们要求的期望值: \[\frac{\sum_{i=l}^r\sum_{j=l}^rdis[i][j]}{C_{r-l+1}^{2}}\] 当然是上下两部分分别求,下面肥肠 ...

随机推荐

  1. java中各个类相互调用资源的原理

       当我们要进行跨类的调用/使用的时候,比如当前类调用另一个类中的变量或方法时, 这时需要一定的条件,如果那些将要被调用的变量或方法是static(静态)变量,也叫类变 量,那么可以通过类名调用,相 ...

  2. 引人遐想,用 Python 获取你想要的 “某个人” 摄像头照片

    仅用来学习,希望给你们有提供到学习上的作用. 1.安装库 需要安装python3.5以上版本,在官网下载即可.然后安装库opencv-python,安装方式为打开终端输入命令行. 2.更改收件人和发件 ...

  3. 使用metaweblog API实现通用博客发布 之 版本控制

    使用metaweblog API实现通用博客发布 之 版本控制 接上一篇本地图片自动上传以及替换路径,继续解决使用API发布博客的版本控制问题. 当本地文档修订更新以后,如何发现版本更新,并自动发布到 ...

  4. C# lambda 实现 Ascii 排序

    var dir = new Dictionary<string, string>();            dir.Add("channelId", "1& ...

  5. DEDE判断当前是否有下级栏目,有就显示所有下级栏目,没有就显示同级栏目!

    {dede:channel name='type' runphp='yes' if(reid == "0") @me = "son";else @me = &q ...

  6. 前端js单元测试 使用mocha、chai、sinon,karma

    karma(因果报应)  提供在浏览器上测试  可以同时跑在多个浏览器下 mocha测试框架  其他测试框架还有Jasmine chai断言库  expect = chai.expect sinon ...

  7. python mysql增加改查

    #python mysql增加改查,方便日后copy/paste .......... 1 #encoding: UTF-8 2 import pymysql 3 # # 打开数据库连接 4 db = ...

  8. 利用griddata进行二维插值

    有时候会碰到这种情况: 实际问题可以抽象为 \(z = f(x, y)\) 的形式,而你只知道有限的点 \((x_i,y_i,z_i)\),你又需要局部的全数据,这时你就需要插值,一维的插值方法网上很 ...

  9. spring Data Jpa的依赖+配置

    spring data jpa 是spring基于的orm框架,jpa规范的基础上封装的一套JPA应用框架 添加的相关依赖: <properties> <spring.version ...

  10. 05-IdentityServer4

    前面我们认识了jwt的token颁发模式,其中的应用场景和部分缺陷已经很是了解了.有些场合并不适合jwt,特别是针对第三方进行使用时,比如我们使用qq或者微信登陆博客园或其他第三方应用时. Ids4的 ...